Name:           actor-framework
Version:        0.19.2
Release:        %autorelease
Summary:        An Open Source Implementation of the Actor Model in C++

# https://github.com/actor-framework/actor-framework/issues/1410#issuecomment-1547459576
License:        BSD-3-Clause
URL:            https://github.com/actor-framework/actor-framework
Source0:        %{url}/archive/%{version}/%{name}-%{version}.tar.gz

BuildRequires:  gcc-c++
BuildRequires:  cmake
BuildRequires:  ninja-build
BuildRequires:  openssl-devel
BuildRequires:  doxygen
# optional dependencies for building examples
BuildRequires:  libcurl-devel
BuildRequires:  qt6-qtbase-devel

%description
CAF (the C++ Actor Framework) is an open source implementation of the actor
model for C++ featuring lightweight & fast actor implementations, pattern
matching for messages, network transparent messaging, and more.

%package        devel
Summary:        Development libraries and header files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%package        tools
Summary:        Tools for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    tools
The %{name}-tools package contains tools about %{name}.

%prep
%autosetup -p1

%build
%cmake \
    -G Ninja \
    -DCMAKE_BUILD_TYPE=Release \
    -DCAF_ENABLE_CURL_EXAMPLES=ON \
    -DCAF_ENABLE_QT6_EXAMPLES=ON \
    -DCAF_ENABLE_RUNTIME_CHECKS=ON \
%cmake_build

%install
%cmake_install

%check
%ctest

%files
%license LICENSE
%doc README.md
%{_libdir}/libcaf_*.so.%{version}

%files devel
%{_includedir}/caf/
%{_libdir}/libcaf_*.so
%{_libdir}/cmake/CAF/
%dir %{_datadir}/caf
%{_datadir}/caf/examples/

%files tools
%{_bindir}/caf-run
%{_bindir}/caf-vec

%changelog
%autochangelog
